<?php
##############################################
##	Link Popularity Checker					##
##	Version:		1.1						##
##	Release Date:	03-06-05				##
##------------------------------------------##
##	Website:	http:/www.checkurl.info		##
##	Email:		support@checkurl.info		##
##------------------------------------------##
## Copyright 2005 by Promotion 24 LLC.		##
##############################################
// ensure this file is being included by a parent file
defined( 'P24LINKPOP' ) or die( 'Direct Access to this location is not allowed.' );

// check whether php is compiled with XML
if( function_exists('xml_parser_create') && strtolower($GLOBALS['linkpopConfig']['ENGINES']['google']['misc']) != 'xml' ) {
	$GLOBALS['linkpopConfig']['MISC']['NUSOAP_FUNC'] = FALSE;
	
	function get_google($query) {
		$handle = fsockopen('api.google.com', 80, $errno, $errstr, 30);
		if ($handle) {
			$body = "<?xml version='1.0' encoding='UTF-8'?>\n\n" . 
    "<SOAP-ENV:Envelope xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/1999/XMLSchema\">\n" . 
    "<SOAP-ENV:Body>\n" . 
    "<ns1:doGoogleSearch xmlns:ns1=\"urn:GoogleSearch\" \n" . 
    "SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">\n" . 
    "<key xsi:type=\"xsd:string\">" . $GLOBALS['linkpopConfig']['ENGINES']['google']['apiKey'] . "</key>\n" . 
    "<q xsi:type=\"xsd:string\">" . $query . "</q>\n" . 
    "<start xsi:type=\"xsd:int\">" . 0 . "</start>\n" . 
    "<maxResults xsi:type=\"xsd:int\">10</maxResults>\n" . 
    "<filter xsi:type=\"xsd:boolean\">true</filter>\n" . 
    "<restrict xsi:type=\"xsd:string\">" . $_REQUEST['country'] . "</restrict>\n" . 
    "<safeSearch xsi:type=\"xsd:boolean\">false</safeSearch>\n" . 
    "<lr xsi:type=\"xsd:string\">" . $_REQUEST['language'] . "</lr>\n" . 
    "<ie xsi:type=\"xsd:string\"></ie>\n" . 
    "<oe xsi:type=\"xsd:string\"></oe>\n" . 
    "</ns1:doGoogleSearch>\n" . 
    "</SOAP-ENV:Body>\n" . 
    "</SOAP-ENV:Envelope>\n\n";
			
			fwrite ($handle, "POST /search/beta2 HTTP/1.0\n");
			fwrite ($handle, "Host: api.google.com\n");
			fwrite ($handle, "Content-Type: text/xml; charset=utf-8\n");
			fwrite ($handle, "SOAPAction: \"urn:GoogleSearchAction\"\n");
			fwrite ($handle, "Content-length: " . strlen($body) . "\n\n");
			fwrite ($handle, $body);
			
			while (!feof ($handle)) {
				$string = fgetc ($handle);
				if ($string == '<') break;
			}
			while (!feof($handle)) {
				$string .= fread($handle, 40960);
			}
			fclose($handle);
			return $string;
		}
	}
}
// if PHP is NOT parsed with XML
else {
	$GLOBALS['linkpopConfig']['MISC']['NUSOAP_FUNC'] = TRUE;
	
	// include the class nusoap. This class can be obtained from http://dietrich.ganx4.com/nusoap/index.php
	// Once downloaded, put it in somewhere in your site tree, and change the next line to reflect that
	
	include($GLOBALS['linkpopConfig']['PATH']['extlib']."nusoap.php");
	
	// create a instance of the SOAP client object
	
	// remember that this script is the client,
	// accessing the web service provided by Google
	
	$GLOBALS['linkpopConfig']['ENGINES']['google']['soapclient'] = new soapclient("http://api.google.com/search/beta2");
	
	// uncomment the next line to see debug messages
	// $soapclient->debug_flag = 1;
	
	// set up an array containing input parameters to be
	// passed to the remote procedure
	
	class clsGoogleApi {
	
		// These properties are used in the class:
		var $theResultSet; // holds the results of the search as given by google api
		var $theResults=array(); //holds the results, and is intended to do the traversing
		var $theRowShown=0; // internal field. Holds the index to the last row shown
		var $theMaxResults; // internal field. Holds the given max results parameter to the constructor
		var $flgError = false; // indicates if was there error or not
		var $theSearchQuery; // the Search query as returned by Google Api
		var $theEstimatedResultsCount; // The number of results found by the Api
	
		function clsGoogleApi($search_what,$start,$maxResults) {
			
			$params = array(
				 'key' => $GLOBALS['linkpopConfig']['ENGINES']['google']['apiKey'],   // Google license key. Get your own license, by going to www.google.com/api
				 'q'   => $search_what,                         // search term
				 'start' => $start,                             // start from result n
				 'maxResults' => $maxResults,                   // show a total of n results
				 'filter' => false,                             // remove similar results
				 'restrict' => '',                              // restrict by topic
				 'safeSearch' => false,                         // remove adult links
				 'lr' => '',                                    // restrict by language
				 'ie' => '',                                    // input encoding
				 'oe' => ''                                     // output encoding
			);
	
			// invoke the method on the server
			$this->theResultSet=$GLOBALS['linkpopConfig']['ENGINES']['google']['soapclient']->call("doGoogleSearch", $params, "urn:GoogleSearch", "urn:GoogleSearch");
			$this->theMaxResults=$maxResults;
	
			// print the results of the search
			if ($this->theResultSet['faultstring']) {
				echo $this->theResultSet['faultstring']."<br>";
				$this->flgError=true;
			} else  {
				$this->flgError=false;
				$this->theRowShown=0;
				$this->theSearchQuery=$this->theResultSet['searchQuery'];
				$this->theEstimatedResultsCount=$this->theResultSet['estimatedTotalResultsCount'];
			}
		}
	}
}

function Google($domain,$settings) {
	//define vars
	$return = NULL;

	// set the query
	$query = str_replace("[[FULLURL]]", $domain['fullurl'],
				str_replace("[[DOMAIN]]", $domain['domain'],
				str_replace("[[DOM]]", $domain['dom'],
				str_replace("[[EXT]]", $domain['ext'],
				$settings['apiQuery']))));

	// if XML is not compiled, use NuSOAP
	if( $GLOBALS['linkpopConfig']['MISC']['NUSOAP_FUNC'] == TRUE ) {
		$myQuery = new clsGoogleApi($query,0,0);
	
		// if error has been found
	    if ($myQuery->flgError) {
	    	// error
		} else {
	    	$return = $myQuery->theEstimatedResultsCount;
	    }
	}
	// if PHP is compiled with XML
    else {
		$data = get_google($query);

		$parser = xml_parser_create('UTF-8');
		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1); 
		xml_parse_into_struct($parser, $data, $vals, $index); 
		xml_parser_free($parser);

		$return = $vals[$index['ESTIMATEDTOTALRESULTSCOUNT'][0]]['value'];
    }

    return $return;
}
?>